package com.kingdee.eas.custom.certification.utils;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.*;
import java.time.format.DateTimeFormatter;
import java.time.temporal.ChronoUnit;
import java.time.temporal.TemporalAdjusters;
import java.util.*;

/**
 * ڹ
 * @author coyle
 * @date 2024-11-21
 */
public class DateUtil {

    private static final Logger LOGGER = LoggerFactory.getLogger(DateUtil.class);

    public static final String DATE_FORMAT_YYYY_MM_DD  = "yyyy-MM-dd";
    public static final String DATE_TIME_FORMAT_YYYY_MM_DD_HH_MI_SS = "yyyy-MM-dd HH:mm:ss";
    public static final String DATE_FORMAT_YYYYMM = "yyyyMM";
    public static final String DATE_FORMAT_YYYYMMDD = "yyyyMMdd";
    private static SimpleDateFormat SDFUTC = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss'Z'");
    private static final SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
    private static final SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM");
    private DateUtil() {
        throw new IllegalStateException("Utility class");
    }

    private static DateTimeFormatter dateTimeFormatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");

    /**
     * ȡȥ·ݻ0
     * @param date
     * @return
     */
    public static String simplify(String date){
        int index1 =date.indexOf("-");
        int index2 =date.lastIndexOf("-");
        int month;
        int day;
        int year=Integer.parseInt(date.substring(0,index1));
        if(date.substring(index1+1,index1+2)=="0"){
            month=Integer.parseInt(date.substring(index1+2,index1+3));
        }else {
            month=Integer.parseInt(date.substring(index1+1,index1+3));
        }
        if(date.substring(index2+1,index2+2)=="0"){
            day=Integer.parseInt(date.substring(index2+2,index2+3));
        }else{
            day=Integer.parseInt(date.substring(index2+1,index2+3));
        }
        String date1=(month+"."+day)+"";
        return  date1;
    }

    /**
     *  ݺ ȡһ
     * @return
     */
    public static List<Map> getDataScope(String date){
        String[] timeStrs = date.split("-");
        Calendar c = Calendar.getInstance();
        c.set(Calendar.YEAR, Integer.parseInt(timeStrs[0]));
        c.set(Calendar.MONTH, Integer.parseInt(timeStrs[1]) - 1);
        c.setFirstDayOfWeek(Calendar.MONDAY);
        int weeks = c.getActualMaximum(Calendar.WEEK_OF_MONTH);

        LocalDate localDateate = LocalDate.parse(date, dateTimeFormatter);
        //·ݵһܵʼʱͽʱ
        LocalDate firstDay = localDateate.with(TemporalAdjusters.firstDayOfMonth());
        String firstDayStr = firstDay.format(dateTimeFormatter);
        String sunStr = getSunOfWeek(firstDayStr);

        List<Map> weekInfos = new ArrayList<>();
        for (int i = 1; i <= weeks; i++) {
            Map weekInfo = new HashMap();
            //һܵʼʱǵµ1ţʱ
            if (i == 1) {
                weekInfo.put("start",firstDayStr);
                weekInfo.put("end",sunStr);
                weekInfo.put("order",i);
                //ÿܵһ
            } else if (i < weeks) {
                //sunStrһܵգȡһҪȡsunStrһܵһ
                String monDay = getLastMonOfWeek(sunStr);
                sunStr = getSunOfWeek(monDay);
                weekInfo.put("start",monDay);
                weekInfo.put("end",sunStr);
                weekInfo.put("order",i);
                //һܿܽʱ䲻գҪ
            } else {
                String monDay = getLastMonOfWeek(sunStr);
                //ʱ϶ǵǰµһ
                LocalDate lastDay = localDateate.with(TemporalAdjusters.lastDayOfMonth());
                String endDay = lastDay.format(dateTimeFormatter);
                weekInfo.put("start",monDay);
                weekInfo.put("end",endDay);
                weekInfo.put("order",i);
            }

            weekInfos.add(weekInfo);

        }
        return weekInfos;
    }

    public static boolean isEffectiveDate2(Date nowTime, Date startTime, Date endTime) {
        if (nowTime.getTime() == startTime.getTime()
                || nowTime.getTime() == endTime.getTime()) {
            return true;
        }

        Calendar date = Calendar.getInstance();
        date.setTime(nowTime);

        Calendar begin = Calendar.getInstance();
        begin.setTime(startTime);

        Calendar end = Calendar.getInstance();
        end.setTime(endTime);

        if (date.after(begin) && date.before(end)) {
            return true;
        } else {
            return false;
        }
    }


    //ܵ
    public static String getSunOfWeek(String time) {
        LocalDate localDateate = LocalDate.parse(time, dateTimeFormatter);
        LocalDate endday = localDateate.with(TemporalAdjusters.next(java.time.DayOfWeek.MONDAY)).minusDays(1);
        String endDayStr = endday.format(dateTimeFormatter);
        return endDayStr;
    }

    //һܵһ
    public static String getLastMonOfWeek(String time) {
        LocalDate localDateate = LocalDate.parse(time, dateTimeFormatter);
        LocalDate endday = localDateate.with(TemporalAdjusters.next(java.time.DayOfWeek.MONDAY));
        String endDayStr = endday.format(dateTimeFormatter);
        return endDayStr;
    }


    /**
     * ж  
     * @param date
     */
    public static  String ifAfternoonByDate(Date date) {
        //Ϊ0 Ϊ1
        Calendar calendar =  Calendar.getInstance();
        calendar.setTime(date);
        GregorianCalendar gregorianCalendar = (GregorianCalendar)calendar;
        int index = gregorianCalendar.get(GregorianCalendar.AM_PM);
        if (index == 0) {
            return "";
        }
        return "";
    }
    /**
     * תַ
     * @param date   
     * @param format ʽ
     * @return ַ
     */
    public static String dateToString(Date date, String format) {
        return new SimpleDateFormat(format).format(date);
    }
    public static String dateToUtc(Date date) {
        SDFUTC.setTimeZone(TimeZone.getTimeZone("UTC"));
//        sdfutc.setTimeZone(TimeZone.getTimeZone("GMT"));
        return SDFUTC.format(date);
    }
    /**
     * ַת
     * @param dateStr ַ
     * @param format  ʽ
     * @return 
     */
    public static Date stringToDate(String dateStr, String format) {
        try {
            return new SimpleDateFormat(format).parse(dateStr);
        } catch (ParseException e) {
            e.printStackTrace();
            LOGGER.error(String.format("޷ַ%sתΪ[%s]", dateStr, format), e);
        }
        return null;
    }
    /**
     * ַת
     * @param dateStr ַ
     * @param format  ʽ
     * @return 
     */
    public static Date stringToDate2(String dateStr, String format) {
        try {
            return new SimpleDateFormat(format).parse(dateStr);
        } catch (ParseException e) {
            LOGGER.error(String.format("޷ַ%sתΪ[%s]", dateStr, format), e);
        }
        return new Date();
    }

    /**
     * һ·
     * @param month
     * @author lsw
     * @return
     */
    public static List<String> dayReport(Date month) {
        List<String> fullDayList = new ArrayList<String>();
        Calendar cal = Calendar.getInstance();
        cal.setTime(month);//month Ϊָ·
        int year = cal.get(Calendar.YEAR);
        int m = cal.get(Calendar.MONTH);
        int dayNumOfMonth = cal.getActualMaximum(Calendar.DAY_OF_MONTH);
        cal.set(Calendar.DAY_OF_MONTH, 1);// һſʼ

        for (int i = 0; i < dayNumOfMonth; i++, cal.add(Calendar.DATE, 1)) {
            Date d = cal.getTime();
            SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");
            String df = simpleDateFormat.format(d);
            fullDayList.add(df);
        }
        return fullDayList;
    }
    /**
     * ȡ֮ڼ
     * @param start ʼ
     * @param end   
     * @return ڼ
     */
    public static List<Date> getBetweenDates(Date start, Date end) {
        List<Date> result = new ArrayList<>();
        Calendar tempStart = Calendar.getInstance();
        tempStart.setTime(getDayBegin(start));

        Calendar tempEnd = Calendar.getInstance();
        tempEnd.setTime(getDayBegin(end));
        do {
            result.add(tempStart.getTime());
            tempStart.add(Calendar.DAY_OF_YEAR, 1);
        } while (!tempStart.after(tempEnd));
        return result;
    }
    /**
     * ȡ֮·ݼ
     * @param startDate ʼ
     * @param endDate   
     * @return List<String>

     */
    public static List<String> getBetweenMonths(Date startDate, Date endDate) {
        startDate = startDate==null? new Date(): startDate;
        endDate = endDate==null? new Date(): endDate;

        Calendar start = Calendar.getInstance();
        start.setTime(startDate);//ʼʱ
        start.set(Calendar.DATE, 1);
        Calendar end = Calendar.getInstance();
        end.setTime(endDate);//ýʱ
        end.set(Calendar.DATE, 2);

        List<String> months = new ArrayList<>();
        do {
            months.add(DateUtil.dateToString(start.getTime(), "yyyy_MM"));
            start.add(Calendar.MONTH, 1);
        } while (start.before(end));
        return months;
    }
    /**
     * ȡ֮ÿһ
     * @param startDate ʼ
     * @param endDate   
     * @return List<String>
     */
    public static List<Date> getBetweenLastMonths(Date startDate, Date endDate) {
        startDate = startDate==null? new Date(): startDate;
        endDate = endDate==null? new Date(): endDate;

        Calendar start = Calendar.getInstance();
        start.setTime(startDate);//ʼʱ
        start.set(Calendar.DATE, 1);
        Calendar end = Calendar.getInstance();
        end.setTime(endDate);//ýʱ
        end.set(Calendar.DATE, 2);

        List<Date> months = new ArrayList<>();
        do {
            months.add(DateUtil.lastDayOfMonth(start.getTime()));
            start.add(Calendar.MONTH, 1);
        } while (start.before(end));
        return months;
    }
    /**
     * ȡڷΧڵм
     * @param startDate ʼ
     * @param endDate 
     * @param interval 
     * @param includeEnd ǷǷڽ
     * @return List<Date>
     */
    public static List<Date> getIntervalDays(Date startDate, Date endDate, int interval, boolean includeEnd) {
        Calendar end = Calendar.getInstance();
        end.setTime(endDate);//ýʱ
        end.add(Calendar.DAY_OF_YEAR, 1);

        Calendar start = Calendar.getInstance();
        start.setTime(startDate);//ʼʱ
        start.add(Calendar.DAY_OF_YEAR, interval);
        if (!start.before(end)) {
            return new ArrayList<>();
        }
        List<Date> dateList = new ArrayList<>();
        do {
            dateList.add(start.getTime());
            start.add(Calendar.DAY_OF_YEAR, interval);
        } while (start.before(end));
        if (includeEnd && start.after(end)) {
            dateList.remove(dateList.size() - 1);
        }
        return dateList;
    }
    /**
     * ڼ
     * @param date 
     * @param num 
     * @return Date
     */
    public static Date add(Date date, int num) {
        if (date == null) {
            return null;
        }
        return DateUtil.add(date, num, Calendar.DAY_OF_YEAR);
    }
    /**
     * ڼ
     * @param date 
     * @param num 
     * @param type 
     * @return Date
     */
    public static Date add(Date date, int num, int type) {
        Calendar start = Calendar.getInstance();
        start.setTime(date);//ʼʱ
        start.add(type, num);
        return start.getTime();
    }
    /**
     * ڼ
     * @param date 
     * @param num 
     * @param type 
     * @return Date
     */
    public static Calendar calAdd(Date date, int num, int type) {
        Calendar start = Calendar.getInstance();
        start.setTime(date);//ʼʱ
        start.add(type, num);
        return start;
    }
    /**
     * ȡһһ
     * @param date
     * @return
     */
    public static Date getLastSecond(Date date){
        date = getDayBegin(date);
        Calendar cal = Calendar.getInstance();
        cal.setTime(date);
        cal.add(Calendar.DAY_OF_MONTH,1);
        cal.add(Calendar.SECOND,-1);
        return cal.getTime();
    }
    /**
     * ·һ
     * @param date 
     * @return ·һ
     * @author ˧ΰ
     * @since 20210510-10:55
     */
    public static Date lastDayOfMonth(Date date) {
        Calendar cal = Calendar.getInstance();
        cal.setTime(date);
        cal.set(Calendar.DAY_OF_MONTH, cal.getActualMaximum(Calendar.DAY_OF_MONTH));
        return cal.getTime();
    }

    /**
     * //ȡǰµһ죺
     * @param date
     * @return
     */
    public static Date firstDayOfMonth(Date date)  {
        //ȡǰµһ죺
        Calendar   cal=Calendar.getInstance();//ȡǰ
        cal.setTime(date);
        cal.set(Calendar.DAY_OF_MONTH,1);
        return cal.getTime();
    }
    /**
     * //ȡǰµһ죺
     * @param time
     * @return
     */
    public static String firstDay(String time) throws ParseException {

        Calendar calendar = Calendar.getInstance();
        calendar.setTime(sdf.parse(time.replace("_","-")));
        calendar.add(Calendar.MONTH, 0);
        calendar.set(Calendar.DAY_OF_MONTH,1);
        return format.format(calendar.getTime());
    }

    /**
     * //ȡǰһ
     * @param time
     * @return
     */
    public static String lastDay(String time) throws ParseException {

        Calendar cal = Calendar.getInstance();
        cal.setTime(sdf.parse(time.replace("_","-")));
        cal.set(Calendar.DAY_OF_MONTH, cal.getActualMaximum(Calendar.DAY_OF_MONTH));
        return format.format(cal.getTime());
    }

    public static int getDaysOfMonth(String time) throws ParseException {
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(sdf.parse(time.replace("_","-")));
        return calendar.getActualMaximum(Calendar.DAY_OF_MONTH);
    }
    public static int getDaysOfMonth(Date date) {
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date);
        return calendar.getActualMaximum(Calendar.DAY_OF_MONTH);
    }
    public static Calendar toCalendar(Date date) {
        Calendar cal = Calendar.getInstance();
        cal.setTime(date);
        return cal;
    }
    /**a
     * 
     * @param cal1
     * @param cal2
     * @return
     */
    public static int getBetweendaynum(Calendar cal1, Calendar cal2){
        cal1.set(cal1.get(Calendar.YEAR), cal1.get(Calendar.MONTH), cal1.get(Calendar.DAY_OF_MONTH));
        cal2.set(cal2.get(Calendar.YEAR), cal2.get(Calendar.MONTH), cal2.get(Calendar.DAY_OF_MONTH));
        long time1 = cal1.getTimeInMillis();
        long time2 = cal2.getTimeInMillis();
        long between_days = (time2 - time1) / (1000 * 3600 * 24);
        return (int) between_days;
    }
    public static int getDifDay(Date start, Date end) {
        if (start == null || end == null) {
            return 0;
        }
        return getBetweendaynum(toCalendar(getDayBegin(start)), toCalendar(getDayBegin(end)));
    }
    public static int getDifDay(Date start, Date end, int defaultDiff) {
        if (start == null || end == null) {
            return defaultDiff;
        }
        return getBetweendaynum(toCalendar(getDayBegin(start)), toCalendar(getDayBegin(end)));
    }
    /**
     * 
     * @param start
     * @param end
     * @return
     */
    public static Integer getDifMonth(Calendar start, Calendar end){
        int result = end.get(Calendar.MONTH) - start.get(Calendar.MONTH);
        int month = (end.get(Calendar.YEAR) - start.get(Calendar.YEAR)) * 12;
        return month + result;
    }
    public static Integer getDifMonth(Date start, Date end){
        Calendar startCal = Calendar.getInstance();
        startCal.setTime(start);
        Calendar endCal = Calendar.getInstance();
        endCal.setTime(end);
        int result = endCal.get(Calendar.MONTH) - startCal.get(Calendar.MONTH);
        int month = (endCal.get(Calendar.YEAR) - startCal.get(Calendar.YEAR)) * 12;
        return month + result;
    }
    /**
     * жʱǷʱ
     * @param nowTime
     * @param beginTime
     * @param endTime
     * @return
     */
    public static boolean belongCalendar(Date nowTime, Date beginTime, Date endTime) {
        Calendar date = Calendar.getInstance();
        date.setTime(nowTime);

        Calendar begin = Calendar.getInstance();
        begin.setTime(beginTime);

        Calendar end = Calendar.getInstance();
        end.setTime(endTime);

        return date.after(begin) && date.before(end);
    }

    /**
     * жǷͬһ
     * @param date1
     * @param date2
     * @return
     */
    public static boolean isSameDate(Date date1, Date date2) {
        Calendar cal1 = Calendar.getInstance();
        cal1.setTime(date1);
        Calendar cal2 = Calendar.getInstance();
        cal2.setTime(date2);
        return cal1.get(Calendar.YEAR) == cal2
                .get(Calendar.YEAR);
    }
    /**
     * жǷͬһ
     * @param date1
     * @param date2
     * @return
     */
    public static boolean isSameYearMonth(Date date1, Date date2) {
        Calendar cal1 = Calendar.getInstance();
        cal1.setTime(date1);
        Calendar cal2 = Calendar.getInstance();
        cal2.setTime(date2);
        return cal1.get(Calendar.YEAR) == cal2
                .get(Calendar.YEAR) && cal1.get(Calendar.MONTH) == cal2
                .get(Calendar.MONTH);
    }

    public static boolean isSameYearMonthDay(Date date1, Date date2) {
        Calendar cal1 = Calendar.getInstance();
        cal1.setTime(date1);
        Calendar cal2 = Calendar.getInstance();
        cal2.setTime(date2);
        return cal1.get(Calendar.YEAR) == cal2
                .get(Calendar.YEAR) && cal1.get(Calendar.MONTH) == cal2
                .get(Calendar.MONTH)&& cal1.get(Calendar.DAY_OF_MONTH) == cal2
                .get(Calendar.DAY_OF_MONTH);
    }
    /**
     * ȡƽ
     */
    public static Date getAvgDate(List<Date> dateList) {
        if (dateList.isEmpty()) {
            return null;
        }
        int size = 0;
        long time = 0;
        for (Date date : dateList) {
            if (date != null) {
                time += date.getTime();
                size ++;
            }
        }
        if (time == 0 || size == 0) {
            return null;
        }
        return new Date(time / size);
    }

    /**
     * жǷͬһ
     * @param date1
     * @param date2
     * @return
     */
    public static boolean isSameMouth(Date date1, Date date2) {
        Calendar cal1 = Calendar.getInstance();
        cal1.setTime(date1);
        Calendar cal2 = Calendar.getInstance();
        cal2.setTime(date2);
        return cal1.get(Calendar.MONTH) == cal2
                .get(Calendar.MONTH);
    }
    /**
     * ʱ
     */
    public static Date getDayBegin(Date date) {
        if (date == null) {
            return null;
        }
        Calendar cal = Calendar.getInstance();
        cal.setTime(date);
        cal.set(Calendar.HOUR_OF_DAY, 0);
        cal.set(Calendar.SECOND, 0);
        cal.set(Calendar.MINUTE, 0);
        cal.set(Calendar.MILLISECOND, 0);
        return cal.getTime();
    }

    /**
     * ȡһһ
     * @param date
     * @return
     */
    public static Date getDayEnd(Date date){
        Calendar cal = Calendar.getInstance();
        cal.setTime(date);
        cal.set(Calendar.HOUR_OF_DAY, 23);
        cal.set(Calendar.MINUTE, 59);
        cal.set(Calendar.SECOND, 59);
        return cal.getTime();
    }

    public static Date getYearStart(Date date) {
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        int year = DateUtil.toCalendar(date).get(Calendar.YEAR);
        try {
            return format.parse(year + "-01-01 00:00:00");
        } catch (ParseException e) {
            LOGGER.error("ת", e);
        }
        return null;
    }

    public static Date getYearFirstDay(Date date){
        int year = DateUtil.toCalendar(date).get(Calendar.YEAR);
        Calendar calendar = Calendar.getInstance();
        calendar.clear();
        calendar.set(Calendar.YEAR, year);
        return calendar.getTime();
    }

    public static Date getYearLastDay(Date date) {
        int year = DateUtil.toCalendar(date).get(Calendar.YEAR);
        Calendar calendar = Calendar.getInstance();
        calendar.clear();
        calendar.set(Calendar.YEAR, year);
        calendar.roll(Calendar.DAY_OF_YEAR, -1);
        return calendar.getTime();
    }

    public static Date getMonthLastDay(Date date) {
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(getDateStartTime(date));
        calendar.set(Calendar.DAY_OF_MONTH, calendar.getActualMaximum(Calendar.DAY_OF_MONTH));
        return calendar.getTime();
    }

    public static Date getNextMonthFirstDay(Date date) {
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(getDateStartTime(date));
        calendar.add(Calendar.MONTH, 1);
        calendar.set(Calendar.DAY_OF_MONTH, 1);
        return calendar.getTime();
    }

    /**
     * ָڵʱʽ 00:00:00 ʱ
     * @param date ָ
     * @return date
     */
    public static Date getDateStartTime(Date date) {
        ZoneId utcPlus8 = ZoneId.systemDefault();
        LocalDate localDate = date.toInstant().atZone(utcPlus8).toLocalDate();
        LocalDateTime localDateTime = localDate.atStartOfDay();
        return Date.from(localDateTime.atZone(utcPlus8).toInstant());
    }
    /**
     * ָڵʱʽ 23:59:59 ʱ
     * @param date ָ
     * @return date
     */
    public static Date getDateEndTime(Date date) {
        ZoneId utcPlus8 = ZoneId.systemDefault();
        LocalDate localDate = date.toInstant().atZone(utcPlus8).toLocalDate();
        LocalDateTime localDateTime = localDate.atTime(23, 59, 59);
        return Date.from(localDateTime.atZone(utcPlus8).toInstant());
    }

    /**
     * ȡڼΪʱ0
     * @param firstDate ʼʱ
     * @param secDate ʱ
     * @return ڼľֵ
     */
    public static int daysBetweenIfBlankReturnZero(Date firstDate, Date secDate) {
        if (firstDate == null || secDate == null) {
            return 0;
        }
        return daysBetween(firstDate, secDate);
    }

    /**
     * ȡڼ (  )
     * @param firstDate ʼʱ
     * @param secDate ʱ
     * @return ڼľֵ
     */
    public static int daysBetween(Date firstDate, Date secDate) {
        ZoneId utcPlus8 = ZoneId.systemDefault();
        LocalDate localDate1 = firstDate.toInstant().atZone(utcPlus8).toLocalDate();
        LocalDate localDate2 = secDate.toInstant().atZone(utcPlus8).toLocalDate();
        return localDate2.isAfter(localDate1) ? (int)localDate1.until(localDate2, ChronoUnit.DAYS) : (int)localDate2.until(localDate1, ChronoUnit.DAYS);
    }

    /**
     * ȡڼ (ǰС,Ϊ)
     * a-b = ? Ч
     * @param firstDate ʼʱ
     * @param secDate ʱ
     * @return ڼĲ
     * @author ԭ־
     */
    public static int daysDifference(Date firstDate, Date secDate) {
        ZoneId utcPlus8 = ZoneId.systemDefault();
        LocalDate localDate1 = firstDate.toInstant().atZone(utcPlus8).toLocalDate();
        LocalDate localDate2 = secDate.toInstant().atZone(utcPlus8).toLocalDate();
        return   (int)localDate2.until(localDate1, ChronoUnit.DAYS);
    }


    /**
     * ȡ뵱ǰ i ʱ
     * @param i
     * @return
     */
    public static Date getNearDate(Integer i) {
        // ȡǰϵͳʱ
        LocalDateTime toDay = LocalDateTime.now();
        /*
          жϵʱǷС i 
          true: ȡ8
          false: ȡ8ʱ
         */
        LocalDateTime dateTime = null;
        if(toDay.getHour() < i){
            dateTime = LocalDateTime.of(toDay.toLocalDate(), LocalTime.MIN.withHour(i));
        } else {
            // ȡ8ʱ  ʱ侫ȷi:00:00
            dateTime = LocalDateTime.of(toDay.toLocalDate(), LocalTime.MIN.withHour(i));
            // ݵǰʱȡڶiʱ侫ȷi:00:00
            dateTime  = dateTime.plusDays(1);
        }
        ZonedDateTime zonedDateTime = dateTime.atZone(ZoneId.systemDefault());
        // ʱLocalDateTimeʱʱInstantʱ
        Instant instant = zonedDateTime.toInstant();
        // UTCʱ(Эʱ,UTC + 00:00)ת(,UTC + 8:00)ʱ
        return Date.from(instant);
    }


    /**
     * õǰһ
     * @return
     */
    public static Date getYesterday() {
        Calendar calendar = Calendar.getInstance();
        //õǰһ
        calendar.add(Calendar.DATE, -1);
        return calendar.getTime();
    }



    /**
     * ַתڳLong͵ʱʽΪyyyy-MM-dd HH:mm:ss
     */
    public static Long convertTimeToLong(String time) {
        try {
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            Date newTime= format.parse(time);
            return newTime.getTime();
        } catch (ParseException e) {
            LOGGER.error(String.format("޷ַ%sתΪ[%s]", time, format), e);
        }
        return null;
    }


}
