package com.kingdee.eas.custom.sendmessage.utils;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.eas.base.attachment.AttachmentFactory;
import com.kingdee.eas.base.attachment.AttachmentInfo;
import com.kingdee.eas.base.attachment.AttachmentManagerFacadeFactory;
import com.kingdee.eas.base.attachment.IAttachmentManagerFacade;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.rpts.ctrlreport.osf.OSFExecutor;
import com.kingdee.shr.certificationservice.HRCertificationBillInfo;
import com.kingdee.util.StringUtils;

import javax.servlet.ServletOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.Base64;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;
import java.util.UUID;

/**
 * ȡ浽
 */
public class SaveFileForDisk {
//    private static String HOME_URL = "https://shr-test.gooeto.com:6888/";
    private static Properties propt = new Properties();
   
    
    
    private static void setUrlPath() throws BOSException {
    	String syncOAConfigPath = System.getProperty("EAS_HOME") + "/server/properties/gyt/sendMessage.properties";
        try {
            propt.load(Files.newBufferedReader(Paths.get(syncOAConfigPath), StandardCharsets.UTF_8));
            //propt.load(new FileInputStream(syncOAConfigPath));
        } catch (IOException e) {
            e.printStackTrace();
            String errorMsg = "ȡļã" + syncOAConfigPath + "   " + e.getMessage();
            throw new BOSException(errorMsg);
        }
    }
    
    /**
     * ȡpdfӦϢ
     * elecProofInfo Ϊ֤
     * @param ctx
     * @param elecProofInfo
     * @return
     * @throws BOSException
     * @throws EASBizException
     * @throws IOException
     */
    public static Map<String,String>  getPDFInfo(Context ctx, HRCertificationBillInfo elecProofInfo ) throws BOSException, EASBizException, IOException {
    	setUrlPath();
    	Map<String,String> resultMap = new HashMap();
        //ȡ֤
        String signNo = StringUtils.cnulls(elecProofInfo.getSignNO());
        //ǩɺ󣬵osfԤ֤
        String billId = StringUtils.cnulls(elecProofInfo.getId());
        //osf
        HashMap param = new HashMap<String,String>();
        param.put("contractNo", signNo);
        param.put("billId",  billId);
        param.put("isDefault", "1");
        Map<String, Object> result = (Map<String, Object>) OSFExecutor.executeOSF(ctx, param, "empPreViewECertificationV2Service");
        boolean  isSucc = (Boolean)result.get("isSuccess");
        String returnUrl = StringUtils.cnulls( result.get("returnUrl") );
        //ɹ֤;
        if(isSucc) {
            String folderName =  createFolderName();
            String fileName =  getPDFToDisk(ctx, returnUrl, folderName);
            //Ϣ
            String urlPath  = propt.getProperty("shrPath")+"?sole="+folderName+"&fname="+fileName;
            //ļ
            resultMap.put("dirName",folderName);
            //ļ
            resultMap.put("fileName",fileName);
            //url·
            resultMap.put("urlPath",urlPath);
        }
        return resultMap;
    }

    public static  String  getPDFToDisk(Context ctx, String attachId, String dirName) throws IOException {

        String home = System.getProperty("EAS_HOME"); // ȡ EAS Ŀ¼
        String fileDir = home+"/server/deploy/easweb.ear/shr_web.war/tmp/electronicAttachment/"+ dirName;
        fileDir = fileDir.replace("\\", "/"); //
        ServletOutputStream outputStream = null;
        OutputStream fileOutputStream = null; // ļ
        try {
//            AttachmentInfo ai = AttachmentFactory.getLocalInstance(ctx).getAttachmentInfo(new ObjectUuidPK(attachId));
//            String fileName = ai.getName();
//            String simpleName = ai.getSimpleName();
        	String fileName = createFolderName()+".pdf";
        	IAttachmentManagerFacade iAttachmentManagerFacade = AttachmentManagerFacadeFactory.getLocalInstance(ctx);
            byte[] content = iAttachmentManagerFacade.downLoad(attachId);

            // ȷĿ¼
            File directory = new File(fileDir);
            if (!directory.exists()) {
                directory.mkdirs(); // Ŀ¼
            }
            
            // ָļ·
            File file = new File(directory, fileName);
            fileOutputStream = new FileOutputStream(file); // ļ
            fileOutputStream.write(content); // дļ
            fileOutputStream.flush();
            return fileName;

        } catch (EASBizException | BOSException e) {
            e.printStackTrace();
        } finally {
            try {
                if (fileOutputStream != null) {
                    fileOutputStream.close(); // رļ
                }
                if (outputStream != null) {
                    outputStream.close(); // ر Servlet 
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return "";
    }


    public static String createFolderName () {
        //ʹuuidһ8λַΪļ
        return UUID.randomUUID().toString().replaceAll("-", "").substring(0, 10);
    }

}
